prefix = @prefix@
bindir = ${prefix}/bin

top_srcdir = @srcdir@
srcdir = @srcdir@
VPATH = @srcdir@

CC = @CC@
CFLAGS = @CFLAGS@ $(XCFLAGS)
CPPFLAGS = @CPPFLAGS@ $(XCPPFLAGS)
DEFS = -DHAVE_DIRENT_H $(XDEFS)
LDFLAGS = @LDFLAGS@ $(XLDFLAGS)

# Kpathsea needs this for compiling, programs need it for linking.
LIBTOOL = $(SHELL) $(kpathsea_parent)/libtool

ALL_CPPFLAGS = $(DEFS) -I. -I$(srcdir) -I$(srcdir)/glob -I$(srcdir)/regex \
	-I$(kpathsea_parent) -I$(kpathsea_srcdir_parent) $(CPPFLAGS)
ALL_CFLAGS = $(ALL_CPPFLAGS) $(CFLAGS)
ALL_CXXFLAGS = $(ALL_CPPFLAGS) $(CXXFLAGS)
compile = $(CC) $(ALL_CFLAGS)

.SUFFIXES:
.SUFFIXES: .c .o .lo # in case the suffix list has been cleared, e.g., by web2c
.c.o:
	$(compile) -c $< -o $@

kpathsea_parent = ..
kpathsea_dir = $(kpathsea_parent)/kpathsea
kpathsea_srcdir_parent = $(top_srcdir)/..
kpathsea_srcdir = $(kpathsea_srcdir_parent)/kpathsea
kpathsea = $(kpathsea_dir)/libkpathsea.la

LIBS = -ldos -lm -lz
LOADLIBES = $(kpathsea) $(LIBS) $(XLOADLIBES)

CCLD = $(CC)
link_command = $(CCLD) -o $@ $(LDFLAGS)

# When we link with Kpathsea, have to take account that it might be a
# shared library, etc.
kpathsea_link = $(LIBTOOL) --mode=link $(link_command)

programs = dvihp fmtutil makempx mkocp mkofm mktex

default all: setup-dirs $(programs)

mktex_objs = fileutils.o mktex.o variables.o stackenv.o
mktexlib = $(mktex_objs)

globlib = $(addprefix glob/,fnmatch.o glob.o)
regexlib = $(addprefix regex/,regex.o)

dvihp: dvihp.o $(mktexlib) $(regexlib)
	$(kpathsea_link) $^ $(LOADLIBES)

fmtutil: fmtutil.o $(mktexlib) $(kpathsealib) $(globlib) $(regexlib)
	$(kpathsea_link) $^ $(LOADLIBES)

makempx: makempx.o $(mktexlib) $(regexlib)
	$(kpathsea_link) $^ $(LOADLIBES)

mktex: main.o $(mktexlib) $(kpathsealib) $(globlib) $(regexlib)
	$(kpathsea_link) $^ $(LOADLIBES)

mkocp: mkocp.o stackenv.o
	$(kpathsea_link) $^ $(LOADLIBES)

mkofm: mkofm.o
	$(kpathsea_link) $^ $(LOADLIBES)

clean:
	$(RM) *.o $(programs) $(globlib) $(regexlib)

mktex_progs = mktexlsr    \
        mktexnam          \
        mktexupd          \
        mktexpk           \
        mktexdir          \
        mktexmf           \
        mktextfm

install: setup-dirs $(programs)
	cp fmtutil $(bindir)/mktexfmt
	for prog in $(programs); do \
	  cp $$prog $(bindir); \
	done
	cd $(bindir); \
	for prog in $(mktex_progs); do \
	  $(RM) $$prog; \
	  ln -s mktex $$prog; \
	done

$(programs): | setup-dirs

setup-dirs:
	mkdir -p glob regex

.PHONY: all clean default install setup-dirs
